/*
 * config.c - Configuration dialog box
 */

 #pragma strings(readonly)

 #include "icqskmgr.h"

/*---[ Prototipes ]------------------------------------------------------------------------------------------*/

 static int _System optLoad(const DLGHELPER *,HWND,HICQ,ULONG,char *);
 static int _System optSave(const DLGHELPER *,HWND,HICQ,ULONG,char *);
 static int _System optClick(const DLGHELPER *,HWND,HICQ,ULONG,  USHORT, char * );

 const DLGMGR options   = {     sizeof(DLGMGR),
                                NULL,                   // Configure
                                optLoad,                // Load
                                optSave,                // Save
                                NULL,                   // Cancel
                                NULL,                   // Event
                                NULL,                   // selected
                                optClick,               // click
                                NULL,                   // changed
                                NULL		// sysButton
                        };


/*---[ Implementing ]----------------------------------------------------------------------------------------*/

 void _Export EXPENTRY icqpm_ConfigPage(HICQ icq, void *lixo, ULONG uin, USHORT type, HWND hwnd, const DLGINSERT *mgr, char *buffer)
 {
    if(type != 1)
       return;

    if(mgr->sz != sizeof(DLGINSERT))
    {
       icqWriteSysLog(icq,PROJECT,"Invalid dialog loader");
       return;
    }

    mgr->insert(hwnd, module, 22, &options, CFGWIN_OPTIONS);
 }

 static int optLoad(const DLGHELPER *dlg, HWND hwnd, HICQ icq, ULONG uin, char *buffer)
 {
    if(dlg->sz != sizeof(DLGHELPER))
       return -1;

    dlg->setTextLimit(hwnd,112,0xFF);

    dlg->loadRadioButton(hwnd,0,101,"TaskICON", 3,2);   // Change ICON
    dlg->loadRadioButton(hwnd,0,105,"TaskTITLE",3,2);   // Change Title
    dlg->loadRadioButton(hwnd,0,121,"Quote",3,1);       // Quote

    dlg->loadCheckBox(hwnd,0,124,"Chk4URL",    TRUE);   // Detect URL
    dlg->loadCheckBox(hwnd,0,125,"ESC2Close",  TRUE);   // Close on ESC
    dlg->loadCheckBox(hwnd,0,109,"NextOnSend", TRUE);   // Next after send

    dlg->loadString(hwnd,0,112,"browser",0xFF,"mozilla.exe");

    dlg->loadCheckBox(hwnd,0,114,"urlOpen",    TRUE);   // Enable "Open" Button
    dlg->loadCheckBox(hwnd,0,115,"urlSend",    FALSE);  // Enable "Send to Browser" Button


    return 0;
 }

 static int optSave(const DLGHELPER *dlg, HWND hwnd, HICQ icq, ULONG uin, char *buffer)
 {
    if(dlg->sz != sizeof(DLGHELPER))
       return -1;

    dlg->saveRadioButton(hwnd,0,101,"TaskICON",3);
    dlg->saveRadioButton(hwnd,0,105,"TaskTITLE",3);
    dlg->saveRadioButton(hwnd,0,121,"Quote",3);

    dlg->saveCheckBox(hwnd,0,124,"Chk4URL");
    dlg->saveCheckBox(hwnd,0,125,"ESC2Close");
    dlg->saveCheckBox(hwnd,0,109,"NextOnSend");

    dlg->saveString(hwnd,0,112,"browser",0xFF);

    dlg->saveCheckBox(hwnd,0,114,"urlOpen");
    dlg->saveCheckBox(hwnd,0,115,"urlSend");

    return 0;
 }

 static int _System optClick(const DLGHELPER *dlg, HWND hwnd, HICQ icq, ULONG uin, USHORT id, char *buffer)
 {
    if(id != 113)
       return 0;

    dlg->browseFiles(hwnd,112,0,"browser","*.exe", "Select Browser", NULL, NULL);

    return id;
 }


