/*
 * MAINWIN.C - Processamento da janela principal
 */

 #define INCL_WIN
 #define INCL_WINDIALOGS     /* Window Dialog Mgr Functions  */
 #define INCL_GPI
 #include <os2.h>

 #include <stdio.h>
 #include <string.h>
 #include <stdlib.h>
 #include <skinapi.h>


 #include "msgdlg.h"
 #include "icqskmgr.h"

/*---[ Prototipos ]---------------------------------------------------------------------------------*/

 static void    configure(HWND, ICQWNDINFO *, HICQ, HWND);

 static void    drawItem(HWND,USHORT,POWNERITEM);
 static MRESULT querySize(HWND, USHORT, USHORT);
 static void    loadMenu(HWND, HAB, USHORT, HPS, int, const SHORT *, USHORT *, char *, PPOINTL);
 static void    action(HWND,USHORT,ULONG);
 static void    drawUser(ICQWNDINFO *, HUSER, HPS, PRECTL, ULONG);
 static void    processControl(HWND, USHORT, USHORT);
 static void    sysButton(HWND,ICQWNDINFO *);
 static void    procAccelerator(HWND, ICQWNDINFO *,USHORT);
 static void    callMenu(HWND,MENUCALLBACK *,ULONG);
 static void    loadIcons(HWND, ICQWNDINFO *);
 static void    chk4Timer(HWND);
 static void    ajustTasklist(ICQWNDINFO *, const char *);
 static void    openChildWindow(HWND,struct openWindowParameters *);
 static void    popupMenu(HWND,ICQWNDINFO *,USHORT, ULONG);

extern HWND   g_UserMenu;

/*---[ Implementacao ]------------------------------------------------------------------------------*/

 MRESULT EXPENTRY sknProcedure(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
 {
    BOOL handled = TRUE;

    switch(msg)
    {

    /*---[ Skin messages ]-----------------------------------------*/

    case WMSKN_LOADSKIN:
       //sknLoad(hwnd, ((ICQWNDINFO *) WinQueryWindowPtr(hwnd,0))->skn, winElements, PVOIDFROMMP(mp1));
       break;

    case WMSKN_ACTION:
       action(hwnd,SHORT1FROMMP(mp1),LONGFROMMP(mp2));
       break;

    case WMSKN_ACTIVATEHANDLER: /* MP1=Handler, MP2=ItemID */
       callMenu(hwnd,(MENUCALLBACK *) PVOIDFROMMP(mp1),LONGFROMMP(mp2));
       break;

    case WMSKN_QUERYDRAG:
       if(SHORT1FROMMP(mp2) == 1003)
       {
          ((ICQWNDINFO *) WinQueryWindowPtr(hwnd,0))->flags |= WFLG_DRAG;
          return (MRESULT) TRUE;
       }
       return 0;

    case WM_SIZE:
       //printf( "sknProcedure::WM_SIZE\n");
       WinSetWindowPos( WinWindowFromID(hwnd, 1003),
                        0, 0,0,
                        SHORT1FROMMP(mp2),SHORT2FROMMP(mp2),
                        SWP_MOVE | SWP_SIZE );
       break;


    /*---[ Window messages ]---------------------------------------*/

    case WM_BUTTON2UP:
       printf( "sknProcedure::WM_BUTTON2UP\n");
       WinPopupMenu( hwnd, hwnd, g_UserMenu,
          SHORT1FROMMP(mp1),SHORT2FROMMP(mp1),
          0, PU_HCONSTRAIN | PU_VCONSTRAIN | PU_KEYBOARD | PU_MOUSEBUTTON1);
       //handled = FALSE;
       break;

    case WM_SAVEAPPLICATION:
       icqWriteSysLog(((ICQWNDINFO *) WinQueryWindowPtr(hwnd,0))->icq,PROJECT,"System is terminating");
       icqSystemEvent(((ICQWNDINFO *) WinQueryWindowPtr(hwnd,0))->icq,ICQEVENT_SAVE);
       WinPostMsg(hwnd,WM_CLOSE,0,0);
       handled = FALSE;
       break;
       //return sknDefWindowProc(hwnd, ((ICQWNDINFO *) WinQueryWindowPtr(hwnd,0))->skn, msg, mp1, mp2);

    case WM_CLOSE:
       printf( "sknProcedure::WM_CLOSE\n");
       icqStoreWindow(hwnd, ((ICQWNDINFO *) WinQueryWindowPtr(hwnd,0))->icq, 0, "pos:MainWindow");
       icqSystemEvent(((ICQWNDINFO *) WinQueryWindowPtr(hwnd,0))->icq, ICQEVENT_CLOSING);
       handled = FALSE;
       break;
       //return sknDefWindowProc(hwnd, ((ICQWNDINFO *) WinQueryWindowPtr(hwnd,0))->skn, msg, mp1, mp2);

    case WM_CREATE:
       printf( "sknProcedure::WM_CREATE\n");
       create(hwnd,PVOIDFROMMP(mp2));
       handled = FALSE;
       break;
       //return WinDefWindowProc(hwnd, msg, mp1, mp2);

    case WM_CONTROL:
       processControl(hwnd,SHORT1FROMMP(mp1),SHORT2FROMMP(mp1));
       break;

    case WM_DESTROY:
       printf( "sknProcedure::WM_DESTROY\n");
       destroy(hwnd);
       return WinDefWindowProc(hwnd, msg, mp1, mp2);

    case WM_MEASUREITEM: /* MP1=ID, MP2=Index */
       printf( "sknProcedure::WM_MEASUREITEM\n");
       return querySize(hwnd,SHORT1FROMMP(mp1),SHORT1FROMMP(mp1));

    case WM_DRAWITEM:
       printf( "sknProcedure::WM_DRAWITEM %d\n",SHORT1FROMMP(mp1));
       drawItem(hwnd,SHORT1FROMMP(mp1),PVOIDFROMMP(mp2));
       break;

    case WM_COMMAND:
       if ((ULONG)mp1<1000 || (ULONG)mp1==65535) {
          printf( "icqSetOnlineMode %d\n", (ULONG)mp1);
          icqSetOnlineMode(((ICQWNDINFO *) WinQueryWindowPtr(hwnd,0))->icq, (ULONG)mp1);
       } else if ((ULONG)mp1>=1100)
          procUsrMenu( hwnd, (ICQWNDINFO *) WinQueryWindowPtr(hwnd,0), (ULONG)mp1 - 1100);
       else if ((ULONG)mp1>=1000)
          procSysMenu( hwnd, (ICQWNDINFO *) WinQueryWindowPtr(hwnd,0), (ULONG)mp1 - 1000);
/*
       if(SHORT1FROMMP(mp2) == CMDSRC_ACCELERATOR)
          procAccelerator(hwnd,WinQueryWindowPtr(hwnd,0),SHORT1FROMMP(mp1));
       else if(SHORT1FROMMP(mp1) != 103)
          handled = FALSE;
          //return sknDefWindowProc(hwnd, ((ICQWNDINFO *) WinQueryWindowPtr(hwnd,0))->skn, msg, mp1, mp2);
       else
          icqOpenSystemMessage(((ICQWNDINFO *) WinQueryWindowPtr(hwnd,0))->icq);
*/
       break;

    case WM_TIMER:
       doTimer(hwnd);
       break;

    /*---[ Internas ao plugin ]------------------------------------*/

    case WM_USER+10:
       configure(hwnd,WinQueryWindowPtr(hwnd,0),PVOIDFROMMP(mp1), LONGFROMMP(mp2));
       break;

    case WM_USER+11:
       updateUserList(hwnd, WinQueryWindowPtr(hwnd,0));
#ifdef EXTENDED_LOG
       icqWriteSysLog(((ICQWNDINFO *) WinQueryWindowPtr(hwnd,0))->icq,PROJECT,"Redrawing user list");
#endif
       break;

    case WM_USER+12:    /* Timer */
       chk4Timer(hwnd);
       break;

    case WM_USER+13:    /* System event - MP1 = Code */
       systemEvent(hwnd, WinQueryWindowPtr(hwnd,0), SHORT1FROMMP(mp1));
       break;

    case WM_USER+14:    /* User Event - MP1 = Code, MP2 = UIN */
       userEvent(hwnd,SHORT1FROMMP(mp1),LONGFROMMP(mp2));
       break;

    case WM_USER+15:    /* Warning Window - MP1 = UIN MP2 = ID */
       DBGMessage("Abrir janela de warning");
       break;

    case WM_USER+17:    /* Mudar titulo/icone */
       CHKPoint();
       ajustTasklist(WinQueryWindowPtr(hwnd,0),PVOIDFROMMP(mp1));
       CHKPoint();
       break;

    case WM_USER+18:    /* Open user-away dialog box (MP1=parm) */
       openUserAwayDialog(hwnd,PVOIDFROMMP(mp1));
       break;

    case WM_USER+19:    /* Read icons */
       DBGMessage("Carregar tabela de cones");
       loadIcons(hwnd,WinQueryWindowPtr(hwnd,0));

    case WM_USER+20:
       break;

    case WM_USER+21:   /* Popup menu mp1 = menu mp2=UIN */
       DBGMessage("Popup Menu");
       popupMenu(hwnd,(ICQWNDINFO *) WinQueryWindowPtr(hwnd,0),SHORT1FROMMP(mp1),LONGFROMMP(mp2));
       break;

    case WM_USER+22:   /* Open Window */
       openChildWindow(hwnd,(struct openWindowParameters *) mp1);
       break;

    /*---[ DDE Processing ]----------------------------------------*/

    case WMICQ_DDE:
       ddeInitiate(hwnd, (ICQWNDINFO *) WinQueryWindowPtr(hwnd,0), "MOZILLA", "WWW_OpenURL", "http://www.os2brasil.com.br,,0x0,0x0");
       break;

    case WM_DDE_INITIATEACK:
       ddeInitiateAck(hwnd, (ICQWNDINFO *) WinQueryWindowPtr(hwnd,0), (HWND)mp1, (PDDEINIT)mp2);
       break;

    case WM_DDE_DATA:
       ddeData(hwnd, (ICQWNDINFO *) WinQueryWindowPtr(hwnd,0), (PDDESTRUCT) mp2);
       break;

    /*---[ Drag&Drop ]---------------------------------------------*/

    case DM_DRAGOVER:
       return dragOver(hwnd, (ICQWNDINFO *) WinQueryWindowPtr(hwnd,0), (PDRAGINFO)mp1);

    case DM_DRAGLEAVE:
       return dragLeave(hwnd, (ICQWNDINFO *) WinQueryWindowPtr(hwnd,0));

    case DM_DROP:
       return drop(hwnd, (ICQWNDINFO *) WinQueryWindowPtr(hwnd,0));

    default:
       handled = FALSE;
       break;

    }

    if (!handled)
       return WinDefWindowProc(hwnd, msg, mp1, mp2);

    return 0;
 }

 static void loadIcons(HWND hwnd, ICQWNDINFO *wnd)
 {
    int                         f;
    const ICQMODETABLE          *mode   = icqQueryModeTable(wnd->icq);

    DBGTracex(mode);

    for(f=0;f<8 && mode && mode->descr;f++)
    {
       wnd->ptrMode[f] = WinLoadPointer(HWND_DESKTOP,module,100+mode->icon);
       DBGTracex(wnd->ptrMode[f]);
       mode++;
    }
    WinPostMsg(hwnd,WM_USER+17,0,0);
 }

 static void configure(HWND hwnd, ICQWNDINFO *ctl, HICQ icq, HWND frame)
 {
    /* Configura a janela */
    const SHORT        sysMenu[]        = { 11, 38, 16, 17, -1 };
    const SHORT        usrMenu[]        = { 17, 16, 29, 8, 2, 0, -1 };

    HAB                 hab             = WinQueryAnchorBlock(hwnd);
    const ICQMODETABLE  *mode;
    POINTL              aptl[TXTBOX_COUNT];
    USHORT              cols;
    HPS                 hps;

    MENUITEM mi;
    HWND hwndMenu, hwndPullDown;

    ctl->icq            = icq;
    ctl->frame          = frame;

    hwndMenu = WinWindowFromID( ctl->frame, FID_MENU);
    WinSendMsg(hwndMenu, MM_QUERYITEM, MPFROM2SHORT(200, TRUE), (MPARAM) &mi);                             /* Pointer to MENUITEM */
    hwndPullDown = mi.hwndSubMenu;

    DBGTracex(ctl->frame);

    /* Carrega o menu de opcoes */
    //hps                 = WinGetPS(sknQueryMenuWindow(hwnd,101));
    ctl->cols[0]        = 0;
    for(mode = icqQueryModeTable(icq);mode && mode->descr;mode++)
    {
       /*
       GpiQueryTextBox(    hps,
                           strlen(mode->descr),
                           (char *) mode->descr,
                           TXTBOX_COUNT,
                           aptl);

       cols = (aptl[TXTBOX_TOPRIGHT].x - aptl[TXTBOX_TOPLEFT].x);
       ctl->cols[0] = max(ctl->cols[0],cols);
       sknInsertMenuItem(hwnd,101,mode,0);
       */
       mi.iPosition = MIT_END;
       mi.afStyle = MIS_TEXT;
       mi.afAttribute = 0;
       mi.id = mode->mode;
       mi.hwndSubMenu = NULLHANDLE;
       mi.hItem = 0;
       printf( "add mode %d '%s'\n", mode->mode, mode->descr);
       WinSendMsg( hwndPullDown, MM_INSERTITEM, (MPARAM) &mi,
                 (MPARAM) mode->descr);

    }
    //WinReleasePS(hps);

    /* Carrega o menu de sistema */
/*
    hps                 = WinGetPS(sknQueryMenuWindow(hwnd,102));
    loadMenu(hwnd, hab, 102,  hps, 1000, sysMenu, &ctl->cols[1],ctl->buffer,aptl);
    loadMenu(hwnd, hab, 1003, hps, 1100, usrMenu, &ctl->cols[2],ctl->buffer,aptl);
    WinReleasePS(hps);
*/

    setModeButton(hwnd,ctl,icqQueryOfflineMode(icq));

 }

 static void loadMenu(HWND hwnd, HAB hab, USHORT id, HPS hps, int base, const SHORT *list, USHORT *cols, char *buffer, PPOINTL aptl)
 {
    const SHORT         *opt;
    USHORT              cl;

    *cols = 0;
#if 0
    for(opt = list; *opt >= 0; opt++)
    {
       *buffer = 0;
       if(WinLoadString(hab, module, base + *opt, 0xFF, (PSZ) buffer) )
       {
          GpiQueryTextBox(    hps,
                              strlen(buffer),
                              (char *) buffer,
                              TXTBOX_COUNT,
                              aptl);

          cl = (aptl[TXTBOX_TOPRIGHT].x - aptl[TXTBOX_TOPLEFT].x);
          *cols = max(*cols,cl);
          sknInsertMenuItem(hwnd,id,*opt,buffer);
       }
    }
#endif
 }

 static MRESULT querySize(HWND hwnd, USHORT id, USHORT idx)
 {
    ICQWNDINFO  *ctl = WinQueryWindowPtr(hwnd,0);
    USHORT      rows = 40; //sknQueryIconSize(ctl->skn)+4;

    switch(id)
    {
    case 1003:  /* Lista de usuarios */
       return MRFROM2SHORT(rows,1024);

    case 2000:  /* Menu de usuario */
       return MRFROM2SHORT(rows,ctl->cols[2]);

    case 2002: /* Menu de sistema */
       return MRFROM2SHORT(rows,ctl->cols[1]);

    case 2001:  /* Menu de modo */
       return MRFROM2SHORT(rows,ctl->cols[0]);
    }

    return 0;
 }

 static void drawItem(HWND hwnd, USHORT id, POWNERITEM i)
 {
    const ICQMODETABLE  *mode;
    ICQWNDINFO          *ctl = WinQueryWindowPtr(hwnd,0);

#if 0
    switch(id)
    {
    case 1003:  /* Listbox */
       drawUser(ctl, (HUSER) i->hItem, i->hps, &i->rclItem, i->fsState);
       break;


    case 2000:  /* User menu */
    case 2002:  /* System menu */
       i->rclItem.xLeft += sknDrawIcon(ctl->skn, i->hps, i->idItem, i->rclItem.xLeft+4,i->rclItem.yBottom+3);
       i->rclItem.xLeft += 8;
       WinDrawText(   i->hps,
                      -1,
                      (char *) i->hItem,
                      &i->rclItem,
                      i->fsState & 1 ? SKC_SELECTEDFOREGROUND : SKC_FOREGROUND,
                      2,
                      DT_LEFT|DT_VCENTER);

       break;

    case 2001:  /* Mode menu */
       mode = (const ICQMODETABLE *) i->idItem;

       i->rclItem.xLeft += sknDrawIcon(ctl->skn, i->hps, mode->icon, i->rclItem.xLeft+4,i->rclItem.yBottom+3);
       i->rclItem.xLeft += 8;

       WinDrawText(   i->hps,
                      -1,
                      (char *) mode->descr,
                      &i->rclItem,
                      i->fsState & 1 ? SKC_SELECTEDFOREGROUND : SKC_FOREGROUND,
                      2,
                      DT_LEFT|DT_VCENTER);

       break;

    case 101:   /* Botao de selecao de modo */

       if(!(i->idItem & 8000))
       {
          mode = (const ICQMODETABLE *) i->hItem;

          if(mode)
          {
             if(ctl->flags & WFLG_CONNECTING)
             {
                i->rclItem.xLeft += sknDrawIcon(ctl->skn, i->hps, 18+(ctl->modeTicks&7) , i->rclItem.xLeft+2,i->rclItem.yBottom+3);
                i->rclItem.xLeft += 2;
             }
             else
             {
                i->rclItem.xLeft += sknDrawIcon(ctl->skn, i->hps, mode->icon, i->rclItem.xLeft+2,i->rclItem.yBottom+3);
                i->rclItem.xLeft += 2;
             }

             WinDrawText(   i->hps,
                            -1,
                            (char *) mode->descr,
                            &i->rclItem,
                            SKC_FOREGROUND,
                            2,
                            DT_LEFT|DT_VCENTER);
          }
       }
       break;

    case 103:   /* Botao de sistema */

       ctl->iconSize     =  sknDrawIcon(ctl->skn, i->hps, ctl->modeIcon, i->rclItem.xLeft+2,i->rclItem.yBottom+3)+2;

       if(ctl->eventIcon != ctl->modeIcon && (ctl->timer & 1) )
          sknDrawIcon(ctl->skn, i->hps, ctl->eventIcon, i->rclItem.xLeft+2,i->rclItem.yBottom+3)+2;

       i->rclItem.xLeft += (ctl->iconSize+4);

       WinDrawText(   i->hps,
                      -1,
                      (char *) i->hItem,
                      &i->rclItem,
                      SKC_USER4,
                      2,
                      DT_LEFT|DT_VCENTER);
       break;

    default:
       sknDefWindowProc(hwnd, ((ICQWNDINFO *) WinQueryWindowPtr(hwnd,0))->skn, WM_DRAWITEM, MPFROMSHORT(id), MPFROMP(i));

    }
#endif
 }

 static void action(HWND hwnd, USHORT id, ULONG parm)
 {
    ICQWNDINFO *ctl = WinQueryWindowPtr(hwnd,0);

    switch(id)
    {
    case 2001:  /* Menu de selecao de modo */
       DBGTracex( ((ICQMODETABLE * ) parm)->mode );
       icqSetOnlineMode(ctl->icq, ((ICQMODETABLE * ) parm)->mode );
       break;

    case 2002:  /* Menu de sistema */
       procSysMenu(hwnd,ctl,parm);
       break;

    case 2000:  /* Menu de usuario */
       //procUsrMenu(hwnd, sknQuerySelectedHandle(hwnd,1003), ctl, parm);
       break;
    }

 }

 static void drawUser(ICQWNDINFO *ctl, HUSER usr, HPS hps, PRECTL rcl, ULONG flags)
 {
    HSKIN       skn     = ctl->skn;
    ULONG       offline = icqQueryOfflineMode(ctl->icq);
    ULONG       color;
    USHORT      left;

#if 0
    if(flags & 0x80000000)
    {
       /* It's drawing in the cache bitmap, draw only images */
       left = sknDrawIcon(skn, hps, usr->modeIcon, rcl->xLeft+4,rcl->yBottom+3);

       if(flags&2)
          sknDrawIcon(skn, hps, usr->eventIcon, rcl->xLeft+4,rcl->yBottom+3);

       rcl->xLeft += (8+left);

    }

//    usr->flags |= USRF_BLINK;

    if(flags & 0x40000000)
    {
       /* It's drawing on the screen, the images was already draw from the cache bitmap */
       if(flags & 1)
       {
          color = SKC_SELECTEDFOREGROUND;
       }
       else if(usr->flags & USRF_BLINK)
       {
          ctl->flags |= WFLG_BLINKTEXT;
          if(usr->mode == offline)
             color =  (ctl->timer&1) ? SKC_USER1 : SKC_USER3;
          else
             color =  (ctl->timer&1) ? SKC_USER3 : SKC_USER1;
       }
       else if(usr->mode == offline)
       {
          color = (usr->flags & USRF_WAITING) ? SKC_USER5 : SKC_USER1;
       }
       else
       {
          color = (usr->flags & USRF_WAITING) ? SKC_USER6 : SKC_USER3;
       }

//        CMD_PALLETE, SKC_USER1,         0,                      "OfflineColor",
//        CMD_PALLETE, SKC_USER3,         0,                      "OnlineColor",
//        CMD_PALLETE, SKC_USER4,         0,                      "SysMessageColor",
//        CMD_PALLETE, SKC_USER5,         0,                      "OfflineWaitingColor",
//        CMD_PALLETE, SKC_USER6,         0,                      "OnlineWaitingColor",

       WinDrawText(   hps,
                   -1,
                   (PSZ) icqQueryUserNick(usr),
                   rcl,
                   color,
                   2,
                   DT_LEFT|DT_VCENTER);
    }
#endif

 }

 static void processControl(HWND hwnd, USHORT id, USHORT cmd)
 {
    HUSER usr;
    //ICQWNDINFO *ctl = ((ICQWNDINFO *) WinQueryWindowPtr(hwnd,0))->icq;
    ICQWNDINFO *ctl = WinQueryWindowPtr(hwnd,0);
    int item;
    char nick[256];
    char* nick2;

    if(id != 1003 || cmd != LN_ENTER)
       return;

   item = WinQueryLboxSelectedItem(WinWindowFromID(hwnd,1003));
   WinQueryLboxItemText( WinWindowFromID(hwnd,1003), item, nick, sizeof(nick));
   nick2 = strchr(nick,' ')+1;
   usr = icqQueryUserByNick(ctl->icq, nick2);
   printf("usr %d '%s'\n", usr, nick2);

    for(usr = icqQueryFirstUser(ctl->icq);usr;usr = icqQueryNextUser(ctl->icq,usr))
    {
       if( !stricmp(nick2,icqQueryUserNick(usr)))
          printf("usr loop %d '%s'\n", usr, nick2);
    }

   procUsrMenu( hwnd, (ICQWNDINFO *) WinQueryWindowPtr(hwnd,0), 0);

/*
   item = WinQueryLboxSelectedItem(WinWindowFromID(hwnd,1003));
   WinQueryLboxItemText( WinWindowFromID(hwnd,1003), item, nick, sizeof(nick));
   nick2 = strchr(nick,' ')+1;
   usr = icqQueryUserByNick(icq, nick2);
   printf("usr %d '%s'\n", usr, nick2);

   if(usr)
       icqOpenUserMessageWindow( ((ICQWNDINFO *) WinQueryWindowPtr(hwnd,0))->icq, usr);
*/

 }

 static void procAccelerator(HWND hwnd, ICQWNDINFO *ctl, USHORT id)
 {
    DBGTrace(id);

    switch(id)
    {
    case 2000:
       DBGMessage("Recarregar Skin");
       //querySkinName(ctl->icq, ctl->buffer);
       //sknReloadSkin(hwnd, ctl->buffer, ctl->skn, winElements);
       break;

    case 2001:
       ctl->flags |= WFLG_SORT;
       break;

    case 2002:
       DBGMessage("Redesenhar listbox");
       //sknRedrawControl(hwnd,1003);
       break;

    case ICQMSGC_CLOSE:
       WinPostMsg(hwnd,WM_CLOSE,0,0);
       break;

    case ICQMSGC_SEND:
       processControl(hwnd, 1003, LN_ENTER);
       break;

    }
 }

 static void callMenu(HWND hwnd, MENUCALLBACK *cbk, ULONG item)
 {
    HUSER usr = sknQuerySelectedHandle(hwnd,1003);
    ULONG uin = 0;

    if(usr)
       uin = usr->uin;

    if(cbk)
       cbk(((ICQWNDINFO *) WinQueryWindowPtr(hwnd,0))->icq, uin, item, uin);

 }


 static void chk4Timer(HWND hwnd)
 {
    ICQWNDINFO *ctl = WinQueryWindowPtr(hwnd,0);

    if(ctl->flags & WFLG_REDRAW)
       WinPostMsg(hwnd,WM_USER+11,0,0);

    if(ctl->flags & WFLG_SORT)
    {
       DBGMessage("Reordenar a lista");
       ctl->flags &= ~WFLG_SORT;
       sknSort(hwnd,1003);
       checkUserList(hwnd, ctl);
    }

 }

 static void ajustTasklist(ICQWNDINFO *ctl, const char *txt)
 {
    CHKPoint();
    icqAjustFrameTitle(ctl->icq, ctl->frame, txt, ctl->ptrMode);
    CHKPoint();
 }

 static void openChildWindow(HWND hwnd,struct openWindowParameters *parm)
 {

    ICQWNDINFO *ctl = WinQueryWindowPtr(hwnd,0);

    DBGMessage("*** Recebida requisicao de abertura de janela");
    DBGTracex(parm);

    if(!parm || (parm->sz != sizeof(struct openWindowParameters)) )
    {
       icqWriteSysLog(ctl->icq,PROJECT,"Invalid open child request");
       return;
    }

    DBGTracex(parm->callback);
    parm->callback(ctl->icq,hwnd,parm->id,parm->arg);
    parm->flag = 0;

    CHKPoint();
 }

 static void popupMenu(HWND hwnd, ICQWNDINFO *wnd, USHORT menu, ULONG uin)
 {
    DBGTrace(menu);
    DBGTracex(WinWindowFromID(hwnd,menu));
    WinSendDlgItemMsg(hwnd,menu,WMSKN_SHOWMENU,0,0);
 }

