/*
 * SYSMENU.C - Processa selecoes pelo menu do sistema
 */

 #include <stdio.h>

 #include "icqskmgr.h"

/*---[ Prototipos ]---------------------------------------------------------------------------------*/

 static void updateAll(HICQ);

/*---[ Implementacao ]------------------------------------------------------------------------------*/

 void procSysMenu(HWND hwnd, ICQWNDINFO *ctl, ULONG id)
 {
    DBGTrace(id);

    switch(id)
    {
    case 38:            /* Disconnect */
       icqWriteSysLog(ctl->icq,PROJECT,"Disconnect request received");
       icqDisconnect(ctl->icq);
       break;

    case 26:            /* About pwICQ */
       break;

    case 28:            /* Current user info */
       break;

    case 27:            /* Configure */
       break;

    case 11:            /* Search/Add users */
       icqOpenSearchWindow(ctl->icq,0);
       break;

    case 16:            /* Update all users */
       icqWriteSysLog(ctl->icq,PROJECT,"Updating all users in the contact list");
       updateAll(ctl->icq);
       break;

    case 49:            /* My White Page */
       break;

    case 17:            /* Shutdown */
       icqWriteSysLog(ctl->icq,PROJECT,"Stopping by user request");
       WinPostMsg(hwnd,WM_CLOSE,0,0);
       break;

    }
 }

 static void updateAll(HICQ icq)
 {
    HUSER usr;
    for(usr = icqQueryFirstUser(icq); usr; usr = icqQueryNextUser(icq,usr) )
       usr->flags |= USRF_REFRESH;
 }


