/*
 * SYSMENU.C - Processa selecoes pelo menu de usuario
 */

 #include <stdio.h>
 #include <string.h>



 #include "icqskmgr.h"

/*---[ Prototipos ]---------------------------------------------------------------------------------*/

 static void removeUser(HICQ,HWND,ULONG,char *);

/*---[ Implementacao ]------------------------------------------------------------------------------*/

 void procUsrMenu(HWND hwnd, ICQWNDINFO *ctl, ULONG id)
 {
    HUSER   cursor = 0;
    HUSER   usr = 0;
    char    nick[256];
    char*   nick2;
    int     item;

    DBGTrace(id);

    item = WinQueryLboxSelectedItem(WinWindowFromID(hwnd,1003));
    WinQueryLboxItemText( WinWindowFromID(hwnd,1003), item, nick, sizeof(nick));
    nick2 = strchr(nick,' ')+1;

    for(cursor = icqQueryFirstUser(ctl->icq); cursor; cursor = icqQueryNextUser(ctl->icq,cursor))
    {
        if (!strcmp( nick2, icqQueryUserNick(cursor))) {
           usr = cursor;
           break;
        }
    }

    if(!usr)
       return;

    DBGTrace(usr->uin);

    switch(id)
    {
    case  0: // Send message
       icqNewUserMessage(ctl->icq, usr->uin, MSG_NORMAL, 0, 0);
       break;

    case  2: // Send URL
       icqNewUserMessage(ctl->icq, usr->uin, MSG_URL, 0, 0);
       break;

    case  8: // Ask for authorization
       icqNewUserMessage(ctl->icq, usr->uin, MSG_REQUEST, 0, 0);
       break;

    case  29: // Send authorization
       icqNewUserMessage(ctl->icq, usr->uin, MSG_AUTHORIZED, 0, 0);
       break;

    case 16: // Update basic info
       icqRequestUserUpdate(ctl->icq, usr->uin);
       break;

    case 17: // Remove from list
       removeUser(ctl->icq,hwnd,usr->uin,ctl->buffer);
       break;

    }

 }

 static void removeUser(HICQ icq,HWND hwnd, ULONG uin, char *buffer)
 {
    HUSER       usr             = icqQueryUserHandle(icq,uin);
    HAB         hab             = WinQueryAnchorBlock(hwnd);
    char        title[40];
    char        text[0x0100];

    if(!usr)
    {
       icqWriteSysLog(icq,PROJECT,"Unexpected user handler when deleting");
       return;
    }

    WinLoadString(hab, module, 1203, 0x30, (PSZ) buffer);
    sprintf(title,buffer,uin);

    WinLoadString(hab, module, 1204, 0x80, (PSZ) buffer);
    sprintf(text,buffer,icqQueryUserNick(usr), uin);

    DBGMessage(title);
    DBGMessage(text);

    if( WinMessageBox(  HWND_DESKTOP,
                        hwnd,
                        text,
                        title,
                        10,
                        MB_OKCANCEL|MB_QUERY|MB_APPLMODAL|MB_MOVEABLE|MB_DEFBUTTON2 ) == MBID_OK )
    {
       sprintf(buffer,"Removing %s (ICQ#%d) by user request",icqQueryUserNick(usr),uin);
       DBGMessage(buffer);
       icqWriteSysLog(icq,PROJECT,buffer);
       icqRemoveUser(icq,usr);
    }


 }


